﻿Public Class clsItem
    Public Property nItemID As Integer
    Public Property sItemName As String
    Public Property sDescription As String

    'Public Property lstOwner As List(Of clsUser)
    Public Property lstOwner As Object()
End Class


Public Class clsUser
    Public Property nUserID As Integer
    Public Property nUserName As String
End Class


Public Class Form1

    Dim lstItems As New List(Of clsItem)
    Dim lstUsers As New List(Of clsUser)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        'Create DEMO-Data
        For i As Integer = 1 To 10
            Dim cItem As New clsItem
            cItem.nItemID = i
            cItem.sItemName = "Item " & i
            lstItems.Add(cItem)

            Dim cUser As New clsUser
            cUser.nUserID = i
            cUser.nUserName = "User " & i
            lstUsers.Add(cUser)
        Next

        'Settings UltraComboEditor
        UltraComboEditor1.DataSource = lstUsers
        'UltraComboEditor1.ValueList.DisplayStyle = Infragistics.Win.ValueListDisplayStyle.DisplayText
        UltraComboEditor1.DisplayMember = "nUserName"
        UltraComboEditor1.ValueMember = "nUserID"

        UltraComboEditor1.CheckedListSettings.CheckBoxStyle = Infragistics.Win.CheckStyle.CheckBox
        UltraComboEditor1.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.CheckedItems


        'Settings UltraGrid
        UltraGrid1.DataSource = lstItems
        For Each col As Infragistics.Win.UltraWinGrid.UltraGridColumn In UltraGrid1.DisplayLayout.Bands(0).Columns
            Select Case col.Key
                Case "lstOwner"
                    col.CellAppearance.TextHAlign = Infragistics.Win.HAlign.Left
                    col.EditorComponent = UltraComboEditor1
            End Select
        Next

    End Sub

    Private Sub UltraButton1_Click(sender As Object, e As EventArgs) Handles UltraButton1.Click
        Dim cellValues As Object() = Me.UltraGrid1.Rows(0).Cells("lstOwner").Value

        If (cellValues Is Nothing) Then
            Debug.WriteLine("Cell Value is Nothing")
            Return
        End If

        Debug.WriteLine(String.Format("{0} values selected:", cellValues.Count))
        Debug.Indent()
        For Each cellValue As Object In cellValues
            Debug.WriteLine(cellValue)
        Next
        Debug.Unindent()
    End Sub
End Class